Package: askpass
Type: Package
Title: Password Entry Utilities for R, Git, and SSH
Version: 1.2.1
Authors@R: person("Jeroen", "Ooms", role = c("aut", "cre"), 
    email = "jeroenooms@gmail.com", comment = c(ORCID = "0000-0002-4035-0289"))
Description: Cross-platform utilities for prompting the user for credentials or a 
    passphrase, for example to authenticate with a server or read a protected key.
    Includes native programs for MacOS and Windows, hence no 'tcltk' is required. 
    Password entry can be invoked in two different ways: directly from R via the 
    askpass() function, or indirectly as password-entry back-end for 'ssh-agent' 
    or 'git-credential' via the SSH_ASKPASS and GIT_ASKPASS environment variables.
    Thereby the user can be prompted for credentials or a passphrase if needed 
    when R calls out to git or ssh.
License: MIT + file LICENSE
URL: https://r-lib.r-universe.dev/askpass
BugReports: https://github.com/r-lib/askpass/issues
Encoding: UTF-8
Imports: sys (>= 2.1)
RoxygenNote: 7.2.3
Suggests: testthat
Language: en-US
NeedsCompilation: yes
Packaged: 2024-10-03 14:12:09 UTC; jeroen
Author: Jeroen Ooms [aut, cre] (<https://orcid.org/0000-0002-4035-0289>)
Maintainer: Jeroen Ooms <jeroenooms@gmail.com>
Repository: CRAN
Date/Publication: 2024-10-04 07:20:03 UTC
Built: R 4.3.3; aarch64-apple-darwin20; 2025-01-24 13:55:12 UTC; unix
Archs: askpass.so.dSYM

Package: askpass
Type: Package
Title: Password Entry Utilities for R, Git, and SSH
Version: 1.2.1
Authors@R: person("Jeroen", "Ooms", role = c("aut", "cre"), 
    email = "jeroenooms@gmail.com", comment = c(ORCID = "0000-0002-4035-0289"))
Description: Cross-platform utilities for prompting the user for credentials or a 
    passphrase, for example to authenticate with a server or read a protected key.
    Includes native programs for MacOS and Windows, hence no 'tcltk' is required. 
    Password entry can be invoked in two different ways: directly from R via the 
    askpass() function, or indirectly as password-entry back-end for 'ssh-agent' 
    or 'git-credential' via the SSH_ASKPASS and GIT_ASKPASS environment variables.
    Thereby the user can be prompted for credentials or a passphrase if needed 
    when R calls out to git or ssh.
License: MIT + file LICENSE
URL: https://r-lib.r-universe.dev/askpass
BugReports: https://github.com/r-lib/askpass/issues
Encoding: UTF-8
Imports: sys (>= 2.1)
RoxygenNote: 7.2.3
Suggests: testthat
Language: en-US
NeedsCompilation: yes
Packaged: 2024-10-03 14:12:09 UTC; jeroen
Author: Jeroen Ooms [aut, cre] (<https://orcid.org/0000-0002-4035-0289>)
Maintainer: Jeroen Ooms <jeroenooms@gmail.com>
Repository: CRAN
Date/Publication: 2024-10-04 07:20:03 UTC

.onLoad <- function(libname, pkgname){
  setup_askpass_vars()
}

setup_askpass_vars <- function(){
  if(var_exists('RSTUDIO')){
    fix_rstudio_path()
  } else {
    # This is mostly for RGui and R.app (tty could mean MacOS server)
    if(is_windows() || (is_macos() && !isatty(stdin()))){
      askpass_bin = ssh_askpass()
      if(!var_exists('GIT_ASKPASS')){
        Sys.setenv("GIT_ASKPASS" = askpass_bin)
      }
      if(!var_exists('SSH_ASKPASS')){
        Sys.setenv("SSH_ASKPASS" = askpass_bin)
      }
    }
  }
}

# Try to put 'rpostback-askpass' on the path in RStudio if needed
# See: https://github.com/rstudio/rstudio/issues/3805
fix_rstudio_path <- function(){
  rs_path <- Sys.getenv('RS_RPOSTBACK_PATH')
  git_askpass <- Sys.getenv('GIT_ASKPASS')
  if(nchar(rs_path) && !cmd_exists(git_askpass)){
    PATH <- Sys.getenv("PATH")
    if(!grepl(normalizePath(rs_path, mustWork = FALSE), PATH, fixed = TRUE)){
      rs_path <- unique(c(rs_path, sub("rpostback", 'postback', rs_path)))
      Sys.setenv(PATH = paste(c(PATH, normalizePath(rs_path, mustWork = FALSE)),
                              collapse = .Platform$path.sep))
    }
  }
}

var_exists <- function(var){
  nchar(Sys.getenv(var)) > 0
}

cmd_exists <- function(cmd){
  nchar(Sys.which(cmd)) > 0
}

#' ASKPASS CMD TOOL
#'
#' This returns the path to the native askpass executable which can be used
#' by git-credential or ssh-agent. Most users don't have worry about this.
#'
#' On Windows and MacOS the package automatically sets the `SSH_ASKPASS` and
#' `GIT_ASKPASS` variables on load (if not already set). If these are set
#' you should be able to run e.g. `sys::exec_wait("ssh-add")` and you should
#' be prompted for a passphrase if your key is protected.
#'
#' @export
ssh_askpass <- function(){
  askpass_path(simple = FALSE)
}

is_interactive <- function() {
  opt <- getOption("rlib_interactive")
  if (isTRUE(opt)) {
    TRUE
  } else if (identical(opt, FALSE)) {
    FALSE
  } else if (tolower(getOption("knitr.in.progress", "false")) == "true") {
    FALSE
  } else if (identical(Sys.getenv("TESTTHAT"), "true")) {
    FALSE
  } else {
    interactive()
  }
}

#' Password Prompt Utility
#'
#' Prompt the user for a password to authenticate or read a protected key.
#' By default, this function automatically uses the most appropriate method
#' based on the user platform and front-end. Users or IDEs can override this
#' and set a custom password entry function via the `askpass` option.
#'
#' By default `askpass()` returns `NULL` in non-interactive sessions.
#' (These include knitr runs and testthat tests.)
#' If you want to force a password prompt in non-interactive sessions,
#' set the `rlib_interactive` option to `TRUE`:
#' ```r
#' options(rlib_interactive = TRUE)
#' ```
#'
#' @export
#' @param prompt the string printed when prompting the user for input.
#' @examples \donttest{
#' # Prompt user for passwd
#' pw <- askpass("Please enter your password")
#' }
askpass <- function(prompt = "Please enter your password: "){
  FUN <- getOption("askpass", ask_password_default)
  FUN(prompt)
}

ask_password_default <- function(prompt){
  if(!is_interactive())
    return(NULL)
  if(is_windows()){
    askpass_windows(prompt)
  } else if(is_macos() && !isatty(stdin())){
    askpass_mac(prompt)
  } else {
    readline_silent(prompt)
  }
}

askpass_path <- function(simple = TRUE){
  if(is_windows()){
    arch <- ifelse(identical(.Machine$sizeof.pointer, 4L), "32", "")
    system.file(sprintf('win-askpass%s.exe', arch),
                               package = 'askpass', mustWork = TRUE)
  } else if(is_macos()){
    prog <- ifelse(isTRUE(simple), 'mac-simplepass', 'mac-askpass')
    system.file(prog, package = 'askpass', mustWork = TRUE)
  }
}

askpass_windows <- function(prompt, user = names(prompt)){
  tryCatch({
    res <- sys::exec_internal(askpass_path(), c(prompt, user), timeout = 120)
    out_without_eol(res$stdout)
  }, error = function(e){
    message(e$message)
  })
}

askpass_mac <- function(prompt){
  tryCatch({
    res <- sys::exec_internal(askpass_path(), prompt, timeout = 120)
    out_without_eol(res$stdout)
  }, error = function(e){
    message(e$message)
  })
}

readline_silent <- function(prompt, icon = "\U0001f511 "){
  if(is_unix() && isatty(stdin())){
    if(system('stty -echo') == 0){
      on.exit(system('stty echo'))
    }
  }
  cat(prompt, "\n")
  out <- base::readline(icon)
  cat(" OK\n")
  out
}

is_windows <- function(){
  .Platform$OS.type == 'windows'
}

is_unix <- function(){
  .Platform$OS.type == "unix"
}

is_macos <- function(){
  identical(tolower(Sys.info()[['sysname']]), "darwin")
}

out_without_eol <- function(x){
  sub("\r?\n$", "", rawToChar(x))
}

context("test-option")

test_that("program exists", {
  if(is_windows() || is_macos()){
    expect_true(file.exists(ssh_askpass()))
  }
})

test_that("option askpass is respected", {
  options(askpass = function(...){
    'supersecret'
  })
  expect_equal(askpass(), 'supersecret')
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/askpass.R
\name{askpass}
\alias{askpass}
\title{Password Prompt Utility}
\usage{
askpass(prompt = "Please enter your password: ")
}
\arguments{
\item{prompt}{the string printed when prompting the user for input.}
}
\description{
Prompt the user for a password to authenticate or read a protected key.
By default, this function automatically uses the most appropriate method
based on the user platform and front-end. Users or IDEs can override this
and set a custom password entry function via the \code{askpass} option.
}
\details{
By default \code{askpass()} returns \code{NULL} in non-interactive sessions.
(These include knitr runs and testthat tests.)
If you want to force a password prompt in non-interactive sessions,
set the \code{rlib_interactive} option to \code{TRUE}:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{options(rlib_interactive = TRUE)
}\if{html}{\out{</div>}}
}
\examples{
\donttest{
# Prompt user for passwd
pw <- askpass("Please enter your password")
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ssh.R
\name{ssh_askpass}
\alias{ssh_askpass}
\title{ASKPASS CMD TOOL}
\usage{
ssh_askpass()
}
\description{
This returns the path to the native askpass executable which can be used
by git-credential or ssh-agent. Most users don't have worry about this.
}
\details{
On Windows and MacOS the package automatically sets the \code{SSH_ASKPASS} and
\code{GIT_ASKPASS} variables on load (if not already set). If these are set
you should be able to run e.g. \code{sys::exec_wait("ssh-add")} and you should
be prompted for a passphrase if your key is protected.
}
